Index: palm/trunk/SOURCE/land_surface_model.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model.f90	(revision 1787)
+++ palm/trunk/SOURCE/land_surface_model.f90	(revision 1788)
@@ -1415,238 +1524,266 @@
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
-             DO  k = nzb_soil, nzt_soil
-!
-!--             Calculate volumetric heat capacity of the soil, taking into 
-!--             account water content 
-                rho_c_total(k,j,i) = (rho_c_soil * (1.0_wp - m_sat(j,i))       &
-                                     + rho_c_water * m_soil(k,j,i))
-
-!
-!--             Calculate soil heat conductivity at the center of the soil
-!--             layers
-                lambda_h_sat = lambda_h_sm ** (1.0_wp - m_sat(j,i)) *          &
-                               lambda_h_water ** m_soil(k,j,i)
-
-                ke = 1.0_wp + LOG10(MAX(0.1_wp,m_soil(k,j,i) / m_sat(j,i)))
-
-                lambda_temp(k) = ke * (lambda_h_sat - lambda_h_dry) +          &
-                                 lambda_h_dry
-
-             ENDDO
-
-!
-!--          Calculate soil heat conductivity (lambda_h) at the _stag level 
-!--          using linear interpolation
-             DO  k = nzb_soil, nzt_soil-1
-                lambda_h(k,j,i) = ( lambda_temp(k+1) + lambda_temp(k) ) * 0.5_wp
-             ENDDO
-             lambda_h(nzt_soil,j,i) = lambda_temp(nzt_soil)
-
-!
-!--          Prognostic equation for soil temperature t_soil
-             tend(:) = 0.0_wp
-             tend(nzb_soil) = (1.0_wp/rho_c_total(nzb_soil,j,i)) *             &
-                       ( lambda_h(nzb_soil,j,i) * ( t_soil(nzb_soil+1,j,i)     &
-                         - t_soil(nzb_soil,j,i) ) * ddz_soil(nzb_soil+1)       &
-                         + ghf_eb(j,i) ) * ddz_soil_stag(nzb_soil)
-
-
-
-
-             DO  k = nzb_soil+1, nzt_soil
-                tend(k) = (1.0_wp/rho_c_total(k,j,i))                          &
-                          * (   lambda_h(k,j,i)                                &
-                              * ( t_soil(k+1,j,i) - t_soil(k,j,i) )            &
-                              * ddz_soil(k+1)                                  &
-                              - lambda_h(k-1,j,i)                              &
-                              * ( t_soil(k,j,i) - t_soil(k-1,j,i) )            &
-                              * ddz_soil(k)                                    &
-                            ) * ddz_soil_stag(k)
-             ENDDO
-
-             t_soil_p(nzb_soil:nzt_soil,j,i) = t_soil(nzb_soil:nzt_soil,j,i)   &
-                                             + dt_3d * ( tsc(2)                &
-                                             * tend(:) + tsc(3)                &
-                                             * tt_soil_m(:,j,i) )   
-
-!
-!--          Calculate t_soil tendencies for the next Runge-Kutta step
-             IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  k = nzb_soil, nzt_soil
-                      tt_soil_m(k,j,i) = tend(k)
-                   ENDDO
-                ELSEIF ( intermediate_timestep_count <                         &
-                         intermediate_timestep_count_max )  THEN
-                   DO  k = nzb_soil, nzt_soil
-                      tt_soil_m(k,j,i) = -9.5625_wp * tend(k) + 5.3125_wp      &
-                                         * tt_soil_m(k,j,i)
-                   ENDDO
-                ENDIF
-             ENDIF
-
-
-             DO  k = nzb_soil, nzt_soil
-
-!
-!--             Calculate soil diffusivity at the center of the soil layers
-                lambda_temp(k) = (- b_ch * gamma_w_sat(j,i) * psi_sat          &
-                                  / m_sat(j,i) ) * ( MAX(m_soil(k,j,i),        &
-                                  m_wilt(j,i)) / m_sat(j,i) )**(b_ch + 2.0_wp)
-
-!
-!--             Parametrization of Van Genuchten
-                IF ( soil_type /= 7 )  THEN
-!
-!--                Calculate the hydraulic conductivity after Van Genuchten 
-!--                (1980)
-                   h_vg = ( ( (m_res(j,i) - m_sat(j,i)) / ( m_res(j,i) -       &
-                              MAX(m_soil(k,j,i),m_wilt(j,i)) ) )**(n_vg(j,i)   &
-                              / (n_vg(j,i)-1.0_wp)) - 1.0_wp                   &
-                          )**(1.0_wp/n_vg(j,i)) / alpha_vg(j,i)
-
-
-                   gamma_temp(k) = gamma_w_sat(j,i) * ( ( (1.0_wp +            &
-                                   (alpha_vg(j,i)*h_vg)**n_vg(j,i))**(1.0_wp   &
-                                   -1.0_wp/n_vg(j,i)) - (alpha_vg(j,i)*h_vg    &
-                                   )**(n_vg(j,i)-1.0_wp))**2 )                 &
-                                   / ( (1.0_wp + (alpha_vg(j,i)*h_vg           &
-                                   )**n_vg(j,i))**((1.0_wp - 1.0_wp/n_vg(j,i)) &
-                                   *(l_vg(j,i) + 2.0_wp)) )
-
-!
-!--             Parametrization of Clapp & Hornberger
-                ELSE
-                   gamma_temp(k) = gamma_w_sat(j,i) * (m_soil(k,j,i)           &
-                                   / m_sat(j,i) )**(2.0_wp * b_ch + 3.0_wp)
-                ENDIF
-
-             ENDDO
-
-
-             IF ( humidity )  THEN
-!
-!--             Calculate soil diffusivity (lambda_w) at the _stag level 
-!--             using linear interpolation. To do: replace this with
-!--             ECMWF-IFS Eq. 8.81
+
+             IF ( pave_surface(j,i) )  THEN
+                rho_c_total(nzb_soil,j,i) = pave_heat_capacity
+                lambda_temp(nzb_soil)     = pave_heat_conductivity
+             ENDIF
+
+             IF (  .NOT.  water_surface(j,i) )  THEN
+                DO  k = nzb_soil, nzt_soil
+
+
+                   IF ( pave_surface(j,i)  .AND.  zs(k) <= pave_depth )  THEN
+                    
+                      rho_c_total(k,j,i) = pave_heat_capacity
+                      lambda_temp(k)     = pave_heat_conductivity   
+
+                   ELSE            
+!
+!--                   Calculate volumetric heat capacity of the soil, taking 
+!--                   into account water content 
+                      rho_c_total(k,j,i) = (rho_c_soil * (1.0_wp - m_sat(j,i)) &
+                                           + rho_c_water * m_soil(k,j,i))
+
+!
+!--                   Calculate soil heat conductivity at the center of the soil
+!--                   layers
+                      lambda_h_sat = lambda_h_sm ** (1.0_wp - m_sat(j,i)) *    &
+                                     lambda_h_water ** m_soil(k,j,i)
+
+                      ke = 1.0_wp + LOG10(MAX(0.1_wp,m_soil(k,j,i) / m_sat(j,i)))
+
+                      lambda_temp(k) = ke * (lambda_h_sat - lambda_h_dry) +    &
+                                       lambda_h_dry
+                   ENDIF
+
+                ENDDO
+
+!
+!--             Calculate soil heat conductivity (lambda_h) at the _stag level 
+!--             using linear interpolation. For pavement surface, the
+!--             true pavement depth is considered
                 DO  k = nzb_soil, nzt_soil-1
-                     
-                   lambda_w(k,j,i) = ( lambda_temp(k+1) + lambda_temp(k) )     &
-                                     * 0.5_wp
-                   gamma_w(k,j,i)  = ( gamma_temp(k+1) + gamma_temp(k) )       &
-                                     * 0.5_wp
-
+                   IF ( pave_surface(j,i)  .AND.  zs(k)   < pave_depth         &
+                                           .AND.  zs(k+1) > pave_depth )  THEN
+                      lambda_h(k,j,i) = ( pave_depth - zs(k) ) / dz_soil(k+1)  &
+                                        * lambda_temp(k)                       &
+                                        + ( 1.0_wp - ( pave_depth - zs(k) )    &
+                                        / dz_soil(k+1) ) * lambda_temp(k+1)
+                   ELSE
+                      lambda_h(k,j,i) = ( lambda_temp(k+1) + lambda_temp(k) )  &
+                                        * 0.5_wp
+                   ENDIF
                 ENDDO
-
-!
-!
-!--             In case of a closed bottom (= water content is conserved), set
-!--             hydraulic conductivity to zero to that no water will be lost
-!--             in the bottom layer.
-                IF ( conserve_water_content )  THEN
-                   gamma_w(nzt_soil,j,i) = 0.0_wp
-                ELSE
-                   gamma_w(nzt_soil,j,i) = gamma_temp(nzt_soil)
-                ENDIF     
-
-!--             The root extraction (= root_extr * qsws_veg_eb / (rho_l * l_v))
-!--             ensures the mass conservation for water. The transpiration of
-!--             plants equals the cumulative withdrawals by the roots in the 
-!--             soil. The scheme takes into account the availability of water
-!--             in the soil layers as well as the root fraction in the
-!--             respective layer. Layer with moisture below wilting point will
-!--             not contribute, which reflects the preference of plants to
-!--             take water from moister layers.
-
-!
-!--             Calculate the root extraction (ECMWF 7.69, the sum of root_extr
-!--             = 1). The energy balance solver guarantees a positive
-!--             transpiration, so that there is no need for an additional check.
-                DO  k = nzb_soil, nzt_soil
-                    IF ( m_soil(k,j,i) > m_wilt(j,i) )  THEN
-                       m_total = m_total + root_fr(k,j,i) * m_soil(k,j,i)
-                    ENDIF
-                ENDDO  
-
-                IF ( m_total > 0.0_wp )  THEN
-                   DO  k = nzb_soil, nzt_soil
-                      IF ( m_soil(k,j,i) > m_wilt(j,i) )  THEN
-                         root_extr(k) = root_fr(k,j,i) * m_soil(k,j,i) / m_total
-                      ELSE
-                         root_extr(k) = 0.0_wp
-                      ENDIF
-                   ENDDO
-                ENDIF
-
-!
-!--             Prognostic equation for soil water content m_soil
+                lambda_h(nzt_soil,j,i) = lambda_temp(nzt_soil)
+
+
+
+
+!
+!--             Prognostic equation for soil temperature t_soil
                 tend(:) = 0.0_wp
-                tend(nzb_soil) = ( lambda_w(nzb_soil,j,i) * (                  &
-                            m_soil(nzb_soil+1,j,i) - m_soil(nzb_soil,j,i) )    &
-                            * ddz_soil(nzb_soil+1) - gamma_w(nzb_soil,j,i) - ( &
-                            root_extr(nzb_soil) * qsws_veg_eb(j,i)             &
-                            + qsws_soil_eb(j,i) ) * drho_l_lv )                &
-                            * ddz_soil_stag(nzb_soil)
-
-                DO  k = nzb_soil+1, nzt_soil-1
-                   tend(k) = ( lambda_w(k,j,i) * ( m_soil(k+1,j,i)             &
-                             - m_soil(k,j,i) ) * ddz_soil(k+1) - gamma_w(k,j,i)&
-                             - lambda_w(k-1,j,i) * (m_soil(k,j,i) -            &
-                             m_soil(k-1,j,i)) * ddz_soil(k)                    &
-                             + gamma_w(k-1,j,i) - (root_extr(k)                &
-                             * qsws_veg_eb(j,i) * drho_l_lv)                   &
-                             ) * ddz_soil_stag(k)
+
+                tend(nzb_soil) = (1.0_wp/rho_c_total(nzb_soil,j,i)) *          &
+                          ( lambda_h(nzb_soil,j,i) * ( t_soil(nzb_soil+1,j,i)  &
+                            - t_soil(nzb_soil,j,i) ) * ddz_soil(nzb_soil+1)    &
+                            + ghf_eb(j,i) ) * ddz_soil_stag(nzb_soil)
+
+                DO  k = nzb_soil+1, nzt_soil
+                   tend(k) = (1.0_wp/rho_c_total(k,j,i))                       &
+                             * (   lambda_h(k,j,i)                             &
+                                 * ( t_soil(k+1,j,i) - t_soil(k,j,i) )         &
+                                 * ddz_soil(k+1)                               &
+                                 - lambda_h(k-1,j,i)                           &
+                                 * ( t_soil(k,j,i) - t_soil(k-1,j,i) )         &
+                                 * ddz_soil(k)                                 &
+                               ) * ddz_soil_stag(k)
 
                 ENDDO
-                tend(nzt_soil) = ( - gamma_w(nzt_soil,j,i)                     &
-                                        - lambda_w(nzt_soil-1,j,i)             &
-                                        * (m_soil(nzt_soil,j,i)                &
-                                        - m_soil(nzt_soil-1,j,i))              &
-                                        * ddz_soil(nzt_soil)                   &
-                                        + gamma_w(nzt_soil-1,j,i) - (          &
-                                          root_extr(nzt_soil)                  &
-                                        * qsws_veg_eb(j,i) * drho_l_lv  )      &
-                                      ) * ddz_soil_stag(nzt_soil)             
-
-                m_soil_p(nzb_soil:nzt_soil,j,i) = m_soil(nzb_soil:nzt_soil,j,i)&
-                                                + dt_3d * ( tsc(2) * tend(:)   &
-                                                + tsc(3) * tm_soil_m(:,j,i) )   
-
-!
-!--             Account for dry soils (find a better solution here!)
-                DO  k = nzb_soil, nzt_soil
-                   IF ( m_soil_p(k,j,i) < 0.0_wp )  m_soil_p(k,j,i) = 0.0_wp
-                ENDDO
-
-
-
-
-!
-!--             Calculate m_soil tendencies for the next Runge-Kutta step
+
+                t_soil_p(nzb_soil:nzt_soil,j,i) = t_soil(nzb_soil:nzt_soil,j,i)&
+                                                  + dt_3d * ( tsc(2)           &
+                                                  * tend(nzb_soil:nzt_soil)    & 
+                                                  + tsc(3)                     &
+                                                  * tt_soil_m(:,j,i) )   
+
+!
+!--             Calculate t_soil tendencies for the next Runge-Kutta step
                 IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( intermediate_timestep_count == 1 )  THEN
                       DO  k = nzb_soil, nzt_soil
-                         tm_soil_m(k,j,i) = tend(k)
+                         tt_soil_m(k,j,i) = tend(k)
                       ENDDO
                    ELSEIF ( intermediate_timestep_count <                      &
                             intermediate_timestep_count_max )  THEN
                       DO  k = nzb_soil, nzt_soil
-                         tm_soil_m(k,j,i) = -9.5625_wp * tend(k) + 5.3125_wp   &
-                                     * tm_soil_m(k,j,i)
+                         tt_soil_m(k,j,i) = -9.5625_wp * tend(k) + 5.3125_wp   &
+                                         * tt_soil_m(k,j,i)
                       ENDDO
                    ENDIF
                 ENDIF
 
+
+                DO  k = nzb_soil, nzt_soil
+
+!
+!--                Calculate soil diffusivity at the center of the soil layers
+                   lambda_temp(k) = (- b_ch * gamma_w_sat(j,i) * psi_sat       &
+                                     / m_sat(j,i) ) * ( MAX( m_soil(k,j,i),    &
+                                     m_wilt(j,i) ) / m_sat(j,i) )**(           &
+                                     b_ch + 2.0_wp )
+
+!
+!--                Parametrization of Van Genuchten
+                   IF ( soil_type /= 7 )  THEN
+!
+!--                   Calculate the hydraulic conductivity after Van Genuchten 
+!--                   (1980)
+                      h_vg = ( ( (m_res(j,i) - m_sat(j,i)) / ( m_res(j,i) -    &
+                                 MAX( m_soil(k,j,i), m_wilt(j,i) ) ) )**(      &
+                                 n_vg(j,i) / (n_vg(j,i) - 1.0_wp ) ) - 1.0_wp  &
+                             )**( 1.0_wp / n_vg(j,i) ) / alpha_vg(j,i)
+
+
+                      gamma_temp(k) = gamma_w_sat(j,i) * ( ( (1.0_wp +         &
+                                      ( alpha_vg(j,i) * h_vg )**n_vg(j,i))**(  &
+                                      1.0_wp - 1.0_wp / n_vg(j,i) ) - (        &
+                                      alpha_vg(j,i) * h_vg )**( n_vg(j,i)      &
+                                      - 1.0_wp) )**2 )                         &
+                                      / ( ( 1.0_wp + ( alpha_vg(j,i) * h_vg    &
+                                      )**n_vg(j,i) )**( ( 1.0_wp  - 1.0_wp     &
+                                      / n_vg(j,i) ) *( l_vg(j,i) + 2.0_wp) ) )
+
+!
+!--                Parametrization of Clapp & Hornberger
+                   ELSE
+                      gamma_temp(k) = gamma_w_sat(j,i) * ( m_soil(k,j,i)       &
+                                      / m_sat(j,i) )**(2.0_wp * b_ch + 3.0_wp)
+                   ENDIF
+
+                ENDDO
+
+!
+!--             Prognostic equation for soil moisture content. Only performed,
+!--             when humidity is enabled in the atmosphere and the surface type
+!--             is not pavement (implies dry soil below).
+                IF ( humidity  .AND.  .NOT.  pave_surface(j,i) )  THEN
+!
+!--                Calculate soil diffusivity (lambda_w) at the _stag level 
+!--                using linear interpolation. To do: replace this with
+!--                ECMWF-IFS Eq. 8.81
+                   DO  k = nzb_soil, nzt_soil-1
+                     
+                      lambda_w(k,j,i) = ( lambda_temp(k+1) + lambda_temp(k) )  &
+                                        * 0.5_wp
+                      gamma_w(k,j,i)  = ( gamma_temp(k+1) + gamma_temp(k) )    &
+                                        * 0.5_wp
+
+                   ENDDO
+
+!
+!
+!--                In case of a closed bottom (= water content is conserved), set
+!--                hydraulic conductivity to zero to that no water will be lost
+!--                in the bottom layer.
+                   IF ( conserve_water_content )  THEN
+                      gamma_w(nzt_soil,j,i) = 0.0_wp
+                   ELSE
+                      gamma_w(nzt_soil,j,i) = gamma_temp(nzt_soil)
+                   ENDIF     
+
+!--                The root extraction (= root_extr * qsws_veg_eb / (rho_l * l_v))
+!--                ensures the mass conservation for water. The transpiration of
+!--                plants equals the cumulative withdrawals by the roots in the 
+!--                soil. The scheme takes into account the availability of water
+!--                in the soil layers as well as the root fraction in the
+!--                respective layer. Layer with moisture below wilting point will
+!--                not contribute, which reflects the preference of plants to
+!--                take water from moister layers.
+
+!
+!--                Calculate the root extraction (ECMWF 7.69, the sum of root_extr
+!--                = 1). The energy balance solver guarantees a positive
+!--                transpiration, so that there is no need for an additional check.
+                   DO  k = nzb_soil, nzt_soil
+                       IF ( m_soil(k,j,i) > m_wilt(j,i) )  THEN
+                          m_total = m_total + root_fr(k,j,i) * m_soil(k,j,i)
+                       ENDIF
+                   ENDDO  
+
+                   IF ( m_total > 0.0_wp )  THEN
+                      DO  k = nzb_soil, nzt_soil
+                         IF ( m_soil(k,j,i) > m_wilt(j,i) )  THEN
+                            root_extr(k) = root_fr(k,j,i) * m_soil(k,j,i) / m_total
+                         ELSE
+                            root_extr(k) = 0.0_wp
+                         ENDIF
+                      ENDDO
+                   ENDIF
+
+!
+!--                Prognostic equation for soil water content m_soil.
+                   tend(:) = 0.0_wp
+
+                   tend(nzb_soil) = ( lambda_w(nzb_soil,j,i) * (               &
+                            m_soil(nzb_soil+1,j,i) - m_soil(nzb_soil,j,i) )    &
+                            * ddz_soil(nzb_soil+1) - gamma_w(nzb_soil,j,i) - ( &
+                               root_extr(nzb_soil) * qsws_veg_eb(j,i)          &
+                               + qsws_soil_eb(j,i) ) * drho_l_lv )             &
+                               * ddz_soil_stag(nzb_soil)
+
+                   DO  k = nzb_soil+1, nzt_soil-1
+                      tend(k) = ( lambda_w(k,j,i) * ( m_soil(k+1,j,i)          &
+                                - m_soil(k,j,i) ) * ddz_soil(k+1)              &
+                                - gamma_w(k,j,i)                               &
+                                - lambda_w(k-1,j,i) * (m_soil(k,j,i) -         &
+                                m_soil(k-1,j,i)) * ddz_soil(k)                 &
+                                + gamma_w(k-1,j,i) - (root_extr(k)             &
+                                * qsws_veg_eb(j,i) * drho_l_lv)                &
+                                ) * ddz_soil_stag(k)
+
+                   ENDDO
+                   tend(nzt_soil) = ( - gamma_w(nzt_soil,j,i)                  &
+                                           - lambda_w(nzt_soil-1,j,i)          &
+                                           * (m_soil(nzt_soil,j,i)             &
+                                           - m_soil(nzt_soil-1,j,i))           &
+                                           * ddz_soil(nzt_soil)                &
+                                           + gamma_w(nzt_soil-1,j,i) - (       &
+                                             root_extr(nzt_soil)               &
+                                           * qsws_veg_eb(j,i) * drho_l_lv  )   &
+                                     ) * ddz_soil_stag(nzt_soil)             
+
+                   m_soil_p(nzb_soil:nzt_soil,j,i) = m_soil(nzb_soil:nzt_soil,j,i)&
+                                                   + dt_3d * ( tsc(2) * tend(:)   &
+                                                   + tsc(3) * tm_soil_m(:,j,i) )   
+   
+!
+!--                Account for dry soils (find a better solution here!)
+                   DO  k = nzb_soil, nzt_soil
+                      IF ( m_soil_p(k,j,i) < 0.0_wp )  m_soil_p(k,j,i) = 0.0_wp
+                   ENDDO
+
+!
+!--                Calculate m_soil tendencies for the next Runge-Kutta step
+                   IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                      IF ( intermediate_timestep_count == 1 )  THEN
+                         DO  k = nzb_soil, nzt_soil
+                            tm_soil_m(k,j,i) = tend(k)
+                         ENDDO
+                      ELSEIF ( intermediate_timestep_count <                   &
+                               intermediate_timestep_count_max )  THEN
+                         DO  k = nzb_soil, nzt_soil
+                            tm_soil_m(k,j,i) = -9.5625_wp * tend(k) + 5.3125_wp&
+                                     * tm_soil_m(k,j,i)
+                         ENDDO
+                      ENDIF
+                   ENDIF
+
+                ENDIF
+
              ENDIF
 
           ENDDO
        ENDDO
-
-!
-!--    Calculate surface specific humidity
-       IF ( humidity )  THEN
-          CALL calc_q_surface
-       ENDIF
-
 
     END SUBROUTINE lsm_soil_model
@@ -1656,5 +1793,71 @@
 ! Description:
 ! ------------
-!> Calculation of specific humidity of the surface layer (surface)
+!> Calculation of roughness length for open water (lakes, ocean). The
+!> parameterization follows Charnock (1955). Two different implementations
+!> are available: as in ECMWF-IFS (Beljaars 1994) or as in FLake (Subin et al.
+!> 2012)
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_z0_water_surface
+
+       USE control_parameters,                                                 &
+           ONLY: g, kappa, molecular_viscosity
+
+       IMPLICIT NONE
+
+       INTEGER :: i  !< running index
+       INTEGER :: j  !< running index
+
+       REAL(wp), PARAMETER :: alpha_ch  = 0.018_wp !< Charnock constant (0.01-0.11). Use 0.01 for FLake and 0.018 for ECMWF
+!       REAL(wp), PARAMETER :: pr_number = 0.71_wp !< molecular Prandtl number in the Charnock parameterization (differs from prandtl_number)
+!       REAL(wp), PARAMETER :: sc_number = 0.66_wp !< molecular Schmidt number in the Charnock parameterization
+!       REAL(wp) :: re_0 !< near-surface roughness Reynolds number
+
+
+       DO  i = nxlg, nxrg    
+          DO  j = nysg, nyng
+             IF ( water_surface(j,i) )  THEN
+
+!
+!--             Disabled: FLake parameterization. Ideally, the Charnock 
+!--             coefficient should depend on the water depth and the fetch
+!--             length
+!                re_0 = z0(j,i) * us(j,i) / molecular_viscosity
+!        
+!                z0(j,i) = MAX( 0.1_wp * molecular_viscosity / us(j,i),            &
+!                              alpha_ch * us(j,i) / g )
+!
+!                z0h(j,i) = z0(j,i) * EXP( - kappa / pr_number * ( 4.0_wp * SQRT( re_0 ) - 3.2_wp ) )
+!                z0q(j,i) = z0(j,i) * EXP( - kappa / pr_number * ( 4.0_wp * SQRT( re_0 ) - 4.2_wp ) )
+
+!
+!--              Set minimum roughness length for u* > 0.2
+!                IF ( us(j,i) > 0.2_wp )  THEN
+!                   z0h(j,i) = MAX( 1.0E-5_wp, z0h(j,i) )
+!                   z0q(j,i) = MAX( 1.0E-5_wp, z0q(j,i) )
+!                ENDIF
+
+!
+!--             ECMWF IFS model parameterization after Beljaars (1994). At low
+!--             wind speed, the sea surface becomes aerodynamically smooth and
+!--             the roughness scales with the viscosity. At high wind speed, the
+!--             Charnock relation is used.
+                z0(j,i) =   ( 0.11_wp * molecular_viscosity / us(j,i) )        &
+                          + ( alpha_ch * us(j,i)**2 / g )
+
+                z0h(j,i) = 0.40_wp * molecular_viscosity / us(j,i)
+                z0q(j,i) = 0.62_wp * molecular_viscosity / us(j,i)
+
+             ENDIF
+          ENDDO
+       ENDDO
+
+    END SUBROUTINE calc_z0_water_surface
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculation of specific humidity of the skin layer (surface). It is assumend
+!> that the skin is always saturated.
 !------------------------------------------------------------------------------!
     SUBROUTINE calc_q_surface
@@ -1665,4 +1868,5 @@
        INTEGER :: j              !< running index
        INTEGER :: k              !< running index
+
        REAL(wp) :: resistance    !< aerodynamic and soil resistance term
 
@@ -1701,4 +1905,5 @@
     END SUBROUTINE calc_q_surface
 
+
 !------------------------------------------------------------------------------!
 ! Description:
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1787)
+++ palm/trunk/SOURCE/modules.f90	(revision 1788)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-!
+! Added roughness length for moisture (z0q)
 !
 ! Former revisions:
@@ -384,5 +384,8 @@
           saswsb, saswst, shf, tnudge, td_lsa_lpt, td_lsa_q, td_sub_lpt,       &
           td_sub_q, total_2d_a, total_2d_o, ts, tswst, ug_vert, unudge, us,    &
-          usws, uswst, vnudge, vg_vert, vsws, vswst, wnudge, wsubs_vert, z0, z0h
+          usws, uswst, vnudge, vg_vert, vsws, vswst, wnudge, wsubs_vert,       &
+          z0,                                                                  & !< roughness length for momentum
+          z0h,                                                                 & !< roughness length for heat
+          z0q                                                                    !< roughness length for moisture
 
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
@@ -432,13 +435,14 @@
     USE kinds
 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lwp_av,                & !> Avg. liquid water path
-                                              precipitation_rate_av, & !> Avg. of precipitation rate
-                                              ol_av,                 & !> Avg. of Obukhov length
-                                              qsws_av,               & !> Avg. of surface moisture flux
-                                              shf_av,                & !> Avg. of surface heat flux
-                                              ts_av,                 & !> Avg. of characteristic temperature scale
-                                              us_av,                 & !> Avg. of friction velocity
-                                              z0_av,                 & !> Avg. of roughness length for momentum
-                                              z0h_av                   !> Avg. of roughness length for heat and moisture
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lwp_av,                & !< Avg. liquid water path
+                                              precipitation_rate_av, & !< Avg. of precipitation rate
+                                              ol_av,                 & !< Avg. of Obukhov length
+                                              qsws_av,               & !< Avg. of surface moisture flux
+                                              shf_av,                & !< Avg. of surface heat flux
+                                              ts_av,                 & !< Avg. of characteristic temperature scale
+                                              us_av,                 & !< Avg. of friction velocity
+                                              z0_av,                 & !< Avg. of roughness length for momentum
+                                              z0h_av,                & !< Avg. of roughness length for heat
+                                              z0q_av                   !< Avg. of roughness length for moisture
 
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
